package me.fatmarley.FatTP;

import java.util.logging.Logger;


import net.milkbowl.vault.permission.Permission;

import org.bukkit.ChatColor;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.bukkit.plugin.Plugin;
import org.bukkit.plugin.PluginDescriptionFile;
import org.bukkit.plugin.java.JavaPlugin;
import org.bukkit.plugin.RegisteredServiceProvider;

public class FatTP extends JavaPlugin {

	public final Plugin plugin = this;
	public static final Logger log = Logger.getLogger("Minecraft");
	public static final FatPermissions permissions = new FatPermissions();

	public void onDisable() {
		PluginDescriptionFile pdfFile = getDescription();
		log.info("[" + pdfFile.getName() + "]" + " Version "
				+ pdfFile.getVersion() + "Disabled.");
	}

	public void onEnable() {
		PluginDescriptionFile pdfFile = getDescription();
		log.info("[" + pdfFile.getName() + "]" + " Version "
				+ pdfFile.getVersion() + " loading.");
		if (!setupPermissions()) {
			this.onDisable();
		}
	}

	public boolean onCommand(CommandSender sender, Command cmd,
			String commandLabel, String[] args) {
		if (commandLabel.equalsIgnoreCase("to")) {
			if (!permissions.canGoTo((Player) sender)) {
				sender.sendMessage(ChatColor.RED
						+ "You are not allowed to use this FatTP function!");
				return true;
			}

			for (Player p : getServer().getOnlinePlayers()) {
				if (p.getName().toLowerCase().contains(args[0].toLowerCase())) {
					Teleport((Player) sender, p);
					sender.sendMessage(ChatColor.GREEN
							+ "Successfully teleported to "
							+ p.getDisplayName());
					teleportedMessage(p, (Player) sender, true);
					return true;
				}
			}

			sender.sendMessage(ChatColor.RED + "Couldn't find target for "
					+ args[0]);
			return true;

		} else if (commandLabel.equalsIgnoreCase("from")) {
			if (!permissions.canFrom((Player) sender)) {
				sender.sendMessage(ChatColor.RED
						+ "You are not allowed to use this FatTP function!");
				return true;
			}
//what the hell did i try to do
			//trying to stop people /from staff.
			for (Player p : getServer().getOnlinePlayers()) {
					if (p.getName().toLowerCase().contains(args[0].toLowerCase())) {
					Teleport(p, (Player) sender);
					sender.sendMessage(ChatColor.GREEN
							+ "Successfully teleported " + p.getDisplayName()
							+ " to you");
					teleportedMessage(p, (Player) sender, false);
					return true;

				}
			}
			sender.sendMessage(ChatColor.RED + "Couldn't find target for "
					+ args[0]);
			return true;

		} else if (commandLabel.equalsIgnoreCase("tos")) {
			if (!permissions.canGoToSilent((Player) sender)) {
				sender.sendMessage(ChatColor.RED
						+ "You aren't allowed to Silent TP!");
				return true;

			}
			for (Player p : getServer().getOnlinePlayers()) {
				if (p.getName().toLowerCase().contains(args[0].toLowerCase())) {
					Teleport((Player) sender, p);
					sender.sendMessage(ChatColor.GREEN
							+ "You have silently teleported to "
							+ p.getDisplayName());
					return true;

				}
			}

			sender.sendMessage(ChatColor.RED + "Couldn't find target for "
					+ args[0]);
			return true;
		}

		return false;
	}

	public void teleportedMessage(Player target, Player relatedPlayer,
			boolean to) {
		if (to)
			target.sendMessage(ChatColor.GREEN + relatedPlayer.getDisplayName()
					+ " teleported to you!");
		else
			target.sendMessage(ChatColor.GREEN + "You were teleported to "
					+ relatedPlayer.getDisplayName());
	}

	public void Teleport(Player target, Player destination) {
		target.teleport(destination);
	}

	public boolean setupPermissions() {
		RegisteredServiceProvider<Permission> permissionProvider = getServer()
				.getServicesManager().getRegistration(
						net.milkbowl.vault.permission.Permission.class);

		if (permissionProvider != null) {
			permissions.permission = permissionProvider.getProvider();
			log.info(String.format("[%s] Hooked %s",
					getDescription().getName(), permissionProvider
							.getProvider().getName()));
			return true;
		}
		return false;
	}
}
